import type { ViewProps, HostComponent, ProcessedColorValue } from 'react-native';
import type { WithDefault, DirectEventHandler, Int32 } from 'react-native/Libraries/Types/CodegenTypes';
export declare type CheckBoxEvent = Readonly<{
    target: Int32;
    value: boolean;
}>;
export interface Props extends ViewProps {
    value?: WithDefault<boolean, false>;
    disabled?: WithDefault<boolean, false>;
    onChange?: DirectEventHandler<CheckBoxEvent>;
    onCheckColor?: ProcessedColorValue;
    tintColor?: ProcessedColorValue;
    markSize?: WithDefault<Int32, -1>;
    strokeColor?: ProcessedColorValue;
    boxType?: WithDefault<'circle' | 'square', 'circle'>;
    lineWidth?: WithDefault<Int32, -1>;
}
declare const _default: HostComponent<Props>;
export default _default;
